Package org.spongepowered.asm.mixin.transformer

## Enum ClassInfo.TypeLookup

- java.lang.Object
- - java.lang.Enum<ClassInfo.TypeLookup>
  - - org.spongepowered.asm.mixin.transformer.ClassInfo.TypeLookup

All Implemented Interfaces:
  `java.io.Serializable`, `java.lang.Comparable<ClassInfo.TypeLookup>`

Enclosing class:
  ClassInfo

    public static enum ClassInfo.TypeLookup
    extends java.lang.Enum<ClassInfo.TypeLookup>

When using `ClassInfo.forType`, determines whether an array type should be returned as declared (eg. as `Object` ) or whether the element type should be returned instead.

### Enum Constant Summary

Enum Constants
`DECLARED_TYPE` Return the type as declared in the descriptor.
`ELEMENT_TYPE` Legacy behaviour.

### Method Summary

All Methods Static Methods Concrete Methods
`static ClassInfo.TypeLookup` `valueOf​(java.lang.String name)` Returns the enum constant of this type with the specified name.
`static ClassInfo.TypeLookup[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### DECLARED_TYPE

    public static final ClassInfo.TypeLookup DECLARED_TYPE

Return the type as declared in the descriptor. This means that array types will be treated `Object` for the purposes of type hierarchy lookups returning the correct member methods.

#### ELEMENT_TYPE

    public static final ClassInfo.TypeLookup ELEMENT_TYPE

Legacy behaviour. A lookup by type will return the element type.

### Method Detail

#### values

    public static ClassInfo.TypeLookup[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (ClassInfo.TypeLookup c : ClassInfo.TypeLookup.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static ClassInfo.TypeLookup valueOf​(java.lang.String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
  `java.lang.NullPointerException` - if the argument is null